#include "mash-event.h"

static struct Mash_Queue {
    Mash_QueueEvent *first;
    Mash_QueueEvent *last;
} mash_queue;

void
Mash_QueueInit ()
{
    mash_queue.first = NULL;
    mash_queue.last  = NULL;
}

Mash_QueueEvent *
Mash_RemoveFromEventQueue ()
{
    if (mash_queue.first == NULL) {
        return NULL;
    } else {
        Mash_QueueEvent *event;
        event = mash_queue.first;
        mash_queue.first = event->next;
        if (event == mash_queue.last) {
            // event is the only thing in the queue.
            mash_queue.last = NULL;
        }
        event->next = NULL;
        return event;
    }
}

void
Mash_InsertToEventQueue (Mash_QueueEvent *event)
{
    if (mash_queue.first == NULL) {
        // nothing in the queue.
        mash_queue.first = mash_queue.last = event;
        event->next = NULL;
    } else {
        // XXX : for now, just append to queue.
        mash_queue.last->next = event;
        event->next = NULL;
        mash_queue.last = event;
    }
}
