import RTPApplication
import ScSpatialCombiner

Class SpatApp -superclass RTPApplication

SpatApp instproc init args {
    $self next spat_app

    $self init_resources;

    [$self options] register_option -comm_id comm_id
    [$self options] register_option -cntrl_spec cntrl_spec
    
    eval [$self options] parse_args $args;

    $self instvar spat_obj_
    
    set spat_obj_ [new ScSpatialCombiner [$self get_option comm_id] [$self get_option cntrl_spec]];
}

SpatApp instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
    $self add_option comm_id spat_comb
    $self add_option cntrl_spec 224.3.2.1/22334/16
}

set app [new SpatApp $argv];

puts "Spatial Started"
#vwait forever;

set fps_cntr 0
set fps_cntr_period 3000
proc Count {} {
global fps_cntr fps_cntr_period;

incr fps_cntr 1;
after $fps_cntr_period incr fps_cntr -1;
}

label .l
pack .l

proc UpdateLabel {} {
global fps_cntr fps_cntr_period
.l configure -text "[expr $fps_cntr/($fps_cntr_period/1000.0)]"
after 1000 UpdateLabel 
}
UpdateLabel

set logger [new LogService];
$logger on;

proc Log {bname} {
global logger
$logger log_graph_comm 1 1 [list Completed_Frame [$bname set ts_]];
Count
}

proc Measure {} {
global logger;
$logger on;
$logger reset;
after 20000 "global logger; $logger off; $logger dump [glob ~]/tmp/sc-log.txt; puts {Measurement Done}";
}
