
Class ProgramCache

ProgramCache public init {} {
    $self set children_ {}
}

ProgramCache public addsource s {}

ProgramCache public addprog {src prog} {
    $self instvar progs_ children_
    set progs_([$prog unique_key]) $prog

    # push to listeners
    foreach child $children_ {
	$self sendprog $child add $prog
    }
}

ProgramCache public removeprog {src prog} {
    $self instvar progs_ children_
    set key [$prog unique_key]
    catch { unset progs_($key) }

    # push to listeners
    foreach child $children_ {
	$child send "remove $key\n\n"
    }
}

ProgramCache public updateprog {src prog} {
    $self instvar progs_ children_

    # push to listeners
    foreach child $children_ {
	$self sendprog $child update $prog
    }
}

ProgramCache public subscribe {child} {
    $self instvar children_ progs_
    lappend children_ $child

    # give this child all programs we have so far
    foreach k [array names progs_] {
	$self sendprog $child add $progs_($k)
    }
}

ProgramCache public unsubscribe {child} {
    $self instvar children_
    set i [lsearch -exact $children_ $child]
    if {$i >= 0} {
	set children_ [lreplace $children_ $i $i]
    }
}

ProgramCache private sendprog {child cmd prog} {
    $child send "$cmd\n"
    foreach m [$prog set msgs_] {
	$child send [$m set msgtext_]
    }
    $child send "\n\n"
}

#XXX advertise
