#
# Copyright (c) 1998 Regents of the University of California.
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
# 3. All advertising materials mentioning features or use of this software
#    must display the following acknowledgement:
#       This product includes software developed by the MASH Research
#       Group at the University of California Berkeley.
# 4. Neither the name of the University nor of the Research Group may be
#    used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# ------------

#
#  @(#) $Header: /usr/src/mash/repository/mash/mash-1/tcl/serial/serial.tcl,v 1.7 1998/03/20 05:56:25 hodes Exp $
#


SerialChannel public init { args } {
	eval [list $self] next $args
}

#
# get reply, converted to ascii.  Note that this makes binary data 
# embedded in the stream difficult to deal with, and fails at the
# first 0x00 !
#
SerialChannel public getReply_ascii {} {

	set newReply ""
	set reply [$self getReply]

	set len [llength $reply]
	for {set i 0} {$i < $len} {incr i} {
		append newReply [format "%c" [lindex $reply $i]]
	}
	return $newReply
}


#
# get reply, converted to decimal
#
# (currently this is the "native" encoding passed from C++, and
# thus is identical to the usual "getReply")
#
SerialChannel public getReply_decimal {} {

	# no conversion necessary ...
	set reply [$self getReply]
	return $reply
}

#
# convert reply to hex
#
SerialChannel public getReply_hex {} {

	set newReply ""
	set reply [$self getReply]

	set len [llength $reply]
	for {set i 0} {$i < $len} {incr i} {
		append newReply [format "0x%x" [lindex $reply $i]]
	}
	return $newReply
}
