#ifndef MASH_TGMB_ENUM_H
#define MASH_TGMB_ENUM_H


#define TGMB_VERSION  0x01050201


enum TGMB_MetadataType {
	MetaCacheExpire=1, 
	MetaNoCache, 
	MetaContentType, 
	MetaAggList
};


enum TGMB_ContentType {
	ContentTGMB_GatewayLoc=200,
	ContentTGMB_CanvasCmds,
	ContentTGMB_Control
};


enum ChunkFragDescr {
	/*descrCmd=1,
	descrId,
	descrSrcId,*/
	descrItemType=1,
	descrCoords,
	descrColor,
	descrFill,
	descrFont,
	descrImage,
	descrWidth,
	descrArrow,
	descrText,
	descrImageZoom,
	descrImageBits,

	descrNewPage,
	descrSrcName,
	descrBeginHandshake,
	descrClientStatus,
	descrResendImage,

	descrTimestamp,
	
	descrInvalid
};


enum CanvasCmdType {
	cmdCanvasCreate=1,
	cmdCanvasMove,
	cmdCanvasDelete,
	cmdCanvasConfigText,
	cmdCanvasRaise,
	cmdCanvasUndelete,  /* never seen by the client */
	cmdInvalid
};


enum CanvObjType {
	CanvObjType_Line=1,
	CanvObjType_Arrow,
	CanvObjType_Rect,
	CanvObjType_Oval,
	CanvObjType_Text,
	CanvObjType_Image,
	CanvObjType_Deleted
};


#ifdef TGMB_CLIENT

typedef enum PageItemType_enum {
	PgItemNone=0,			/* in case we need a no-types object */
	PgItemLine,			/* 1 */
	PgItemRect,			/* 2 */
	PgItemOval,			/* 3 */
	PgItemMLine,			/* 4 */
	PgItemText,			/* 5 */
	PgItemImage,			/* 6 */
	PgItemPS,			/* 7 */
	PgItemInvalid			/* This value i	s really num types + 1 */
} PageItemType;


typedef enum ArrowType_enum {
	ArrowNone=0,		/* no arrows */
	ArrowFirst,		/* 1 */
	ArrowLast,		/* 2 */
	ArrowBoth,		/* 3 */
	ArrowInvalid		/* This value is really num types+1 */
} ArrowType;

#endif



#endif /* MASH_TGMB_ENUM_H */
